USE COWS
GO
_CreateObject 'SP','dbo','updateH1NameFromBPM'
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
--=============================================
 --Author:		<Jagannath Gangi>
 --Create date: <03/11/2019>
 --Description:	<This SP retrieves H1 Customer name Change records from BPM(Source-Mach5),
-- then used to update the name in COWS tables and update the BPM view finally with Extract Code = 'Y'>
 --=============================================
----Package: PKG_BPMF_COWS
----procedure Name: proc_BPM_COWS_H1_NME_CHNG(p_h1_cust_id in varchar2,p_xtrct_cd in VARCHAR2)
ALTER PROCEDURE [dbo].[updateH1NameFromBPM]
AS

BEGIN
BEGIN TRY
	SET NOCOUNT ON;
	
	OPEN SYMMETRIC KEY FS@K3y 
	DECRYPTION BY CERTIFICATE S3cFS@CustInf0;

	DECLARE @BPM_COWS_NRFC TABLE	
		(
			ID				INT IDENTITY(1,1),
			H1_CUST_ID			Varchar(9),
			H1_CUST_NME	Varchar(Max),
			XTRCT_CD		Varchar(1),
			XTRCT_DT		Date,
			Flag			BIT
		)
	DECLARE @COWSTbl TABLE	
		(
			ID INT IDENTITY(1,1) NOT NULL, CPT_ID INT, EVENT_ID INT, REDSGN_ID INT, ORDR_ID INT, CSG_LVL_ID TINYINT, Flag BIT
		)
	DECLARE @Cnt Int = 0
	DECLARE @Ctr Int = 1
	Declare @dSQL nvarchar(MAX)
	DECLARE @H1_CUST_ID Varchar(9)
	DECLARE @H1_CUST_NME VARCHAR(MAX)
	DECLARE @XTRCT_CD Varchar(1)
	
	DECLARE @SQL nVarchar(max)
	SET @SQL = ''
	
	SET @SQL = 'SELECT LTRIM(RTRIM(H1_CUST_ID)) AS H1_CUST_ID, LTRIM(RTRIM(H1_CUST_NME)) AS H1_CUST_NME, XTRCT_CD, XTRCT_DT, 0
					FROM OPENQUERY (NRMBPM,		
				''SELECT DISTINCT H1_CUST_ID,H1_CUST_NME,XTRCT_CD,XTRCT_DT
					FROM BPMF_OWNER.BPMF_COWS_H1_DETL  
					WHERE	(XTRCT_CD = ''''N'''') OR (XTRCT_DT IS NULL)
					'') '	
	INSERT INTO @BPM_COWS_NRFC (H1_CUST_ID, H1_CUST_NME,XTRCT_CD,XTRCT_DT,Flag)	
	EXEC sp_executesql @SQL

	SELECT @Cnt = COUNT(1) FROM @BPM_COWS_NRFC
	WHILE (@Ctr <= @Cnt)
	BEGIN
		SELECT TOP 1 @H1_CUST_ID = H1_CUST_ID,
					 @H1_CUST_NME = H1_CUST_NME
		FROM @BPM_COWS_NRFC
		WHERE Flag = 0
		  AND ID = @Ctr

		IF ((LEN(@H1_CUST_ID)=9) AND (LEN(@H1_CUST_NME)>0))
		BEGIN
			INSERT INTO @COWSTbl (CPT_ID, EVENT_ID, REDSGN_ID, ORDR_ID, CSG_LVL_ID, Flag)
			SELECT DISTINCT NULL,ev.EVENT_ID,NULL,NULL,ev.CSG_LVL_ID,0
			FROM dbo.[EVENT] ev WITH (NOLOCK) LEFT JOIN
			dbo.MDS_EVENT me WITH (NOLOCK) ON me.EVENT_ID=ev.EVENT_ID AND me.H1=@H1_CUST_ID LEFT JOIN
			dbo.SIPT_EVENT se WITH (NOLOCK) ON se.EVENT_ID=ev.EVENT_ID AND se.H1=@H1_CUST_ID LEFT JOIN
			dbo.UCaaS_EVENT ue WITH (NOLOCK) ON ue.EVENT_ID=ev.EVENT_ID AND ue.H1=@H1_CUST_ID
			WHERE ((me.EVENT_ID IS NOT NULL) OR (se.EVENT_ID IS NOT NULL) OR (ue.EVENT_ID IS NOT NULL))
			UNION ALL
			SELECT DISTINCT CPT_ID,NULL,NULL,NULL,CSG_LVL_ID,0
			FROM dbo.CPT WITH (NOLOCK)
			WHERE H1=@H1_CUST_ID
			UNION ALL
			SELECT DISTINCT NULL,NULL,NULL,od.ORDR_ID,od.CSG_LVL_ID,0
			FROM dbo.FSA_ORDR_CUST foc WITH (NOLOCK) INNER JOIN
				 dbo.ORDR od WITH (NOLOCK) ON od.ORDR_ID=foc.ORDR_ID
			WHERE foc.CUST_ID=@H1_CUST_ID
			  AND foc.CIS_LVL_TYPE='H1'
			UNION ALL
			SELECT DISTINCT NULL,NULL,REDSGN_ID,NULL,CSG_LVL_ID,0
			FROM dbo.REDSGN WITH (NOLOCK)
			WHERE H1_CD=@H1_CUST_ID
			
		--Update all COWS Tables
		--Update ODIE_REQ
		UPDATE dbo.ODIE_REQ WITH (ROWLOCK)
		SET CUST_NME = @H1_CUST_NME
		WHERE H1_CUST_ID = @H1_CUST_ID
		  AND ISNULL(CSG_LVL_ID,0)=0
		  
		UPDATE csd
		SET csd.CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN
			 dbo.ODIE_REQ od WITH (NOLOCK) ON csd.SCRD_OBJ_ID=od.REQ_ID AND csd.SCRD_OBJ_TYPE_ID=12
		WHERE od.H1_CUST_ID = @H1_CUST_ID
		  AND ISNULL(od.CSG_LVL_ID,0)>0
		  
		--Update ODIE_RSPN
		UPDATE orp
		SET CUST_NME = @H1_CUST_NME
		FROM dbo.ODIE_RSPN orp WITH (ROWLOCK) INNER JOIN
			 dbo.ODIE_REQ od WITH (NOLOCK) ON od.REQ_ID=orp.REQ_ID
		WHERE od.H1_CUST_ID = @H1_CUST_ID
		  AND ISNULL(od.CSG_LVL_ID,0)=0
		  
		UPDATE csd
		SET csd.CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN
			 dbo.ODIE_RSPN orp WITH (NOLOCK) ON csd.SCRD_OBJ_ID=orp.RSPN_ID AND csd.SCRD_OBJ_TYPE_ID=13 INNER JOIN
			 dbo.ODIE_REQ od WITH (NOLOCK) ON od.REQ_ID=orp.REQ_ID
		WHERE od.H1_CUST_ID = @H1_CUST_ID
		  AND ISNULL(od.CSG_LVL_ID,0)>0
		
		--Update REDSGN_CUST_BYPASS
		UPDATE dbo.REDSGN_CUST_BYPASS WITH (ROWLOCK)
		SET CUST_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		WHERE H1_CD = @H1_CUST_ID
		  AND ISNULL(CSG_LVL_ID,0)=0

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 REDSGN_CUST_BYPASS rcb WITH (NOLOCK) ON rcb.ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=17
		WHERE ISNULL(rcb.CSG_LVL_ID,0)>0
		  AND rcb.H1_CD = @H1_CUST_ID
		  
		--Update CPT
		UPDATE cp
		SET COMPNY_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		FROM dbo.CPT cp WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON cp.CPT_ID=ct.CPT_ID
		WHERE ISNULL(ct.CSG_LVL_ID,0)=0
		  AND cp.H1 = @H1_CUST_ID

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.CPT_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=2
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		
		INSERT INTO dbo.CPT_HIST (CPT_ID,ACTN_ID,CMNT_TXT,CREAT_BY_USER_ID,CREAT_DT)	
		SELECT DISTINCT CPT_ID, 79, 'H1 Customer Name has been updated per Mach5', 1, GETDATE()
		FROM @COWSTbl
		WHERE CPT_ID IS NOT NULL
		
		--Update MDS_EVENT
		UPDATE md
		SET CUST_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		FROM dbo.MDS_EVENT md WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=md.EVENT_ID 
		WHERE ISNULL(ct.CSG_LVL_ID,0)=0
		  AND md.H1 = @H1_CUST_ID

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=7
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		
		--Update SIPT_EVENT
		UPDATE sp
		SET CUST_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		FROM dbo.SIPT_EVENT sp WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=sp.EVENT_ID 
		WHERE ISNULL(ct.CSG_LVL_ID,0)=0
		  AND sp.H1 = @H1_CUST_ID

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=18
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		
		--Update UCaaS_EVENT
		UPDATE uc
		SET CUST_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		FROM dbo.UCaaS_EVENT uc WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=uc.EVENT_ID 
		WHERE ISNULL(ct.CSG_LVL_ID,0)=0
		  AND uc.H1 = @H1_CUST_ID

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.EVENT_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=20
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		
		INSERT INTO dbo.EVENT_HIST (EVENT_ID,ACTN_ID,CMNT_TXT,CREAT_BY_USER_ID,MODFD_BY_USER_ID,MODFD_DT,CREAT_DT)
		SELECT DISTINCT EVENT_ID,20,'H1 Customer Name has been updated per Mach5',1,1,GETDATE(),GETDATE()
		FROM @COWSTbl
		WHERE EVENT_ID IS NOT NULL
		
		--Update FSA_ORDR_CUST
		UPDATE foc
		SET CUST_NME = @H1_CUST_NME
		FROM dbo.FSA_ORDR_CUST foc WITH (ROWLOCK) INNER JOIN
			 @COWSTbl ct ON ct.ORDR_ID=foc.ORDR_ID
		WHERE foc.CUST_ID=@H1_CUST_ID
		  AND foc.CIS_LVL_TYPE='H1'
		  
		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 dbo.FSA_ORDR_CUST foc WITH (NOLOCK) ON foc.FSA_ORDR_CUST_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=5 INNER JOIN
			 @COWSTbl ct ON ct.ORDR_ID=foc.ORDR_ID
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		  AND foc.CUST_ID=@H1_CUST_ID
		  AND foc.CIS_LVL_TYPE='H1'
		  
		INSERT INTO ORDR_NTE (NTE_TYPE_ID,ORDR_ID,CREAT_DT,CREAT_BY_USER_ID,REC_STUS_ID,NTE_TXT)
		SELECT DISTINCT 9,ORDR_ID,GETDATE(),1,1,'H1 Customer Name has been updated per Mach5'
		FROM @COWSTbl
		WHERE ORDR_ID IS NOT NULL
		
		--Update REDSGN
		UPDATE rd
		SET CUST_NME = @H1_CUST_NME, MODFD_DT=GETDATE()
		FROM dbo.REDSGN rd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON rd.REDSGN_ID=ct.CPT_ID
		WHERE ISNULL(ct.CSG_LVL_ID,0)=0
		  AND rd.H1_CD = @H1_CUST_ID

		UPDATE csd
		SET CUST_NME = dbo.encryptString(@H1_CUST_NME), MODFD_DT=GETDATE()
		FROM dbo.CUST_SCRD_DATA csd WITH (ROWLOCK) INNER JOIN	
			 @COWSTbl ct ON ct.REDSGN_ID=csd.SCRD_OBJ_ID AND csd.SCRD_OBJ_TYPE_ID=16
		WHERE ISNULL(ct.CSG_LVL_ID,0)>0
		
		INSERT INTO dbo.REDSGN_NOTES (REDSGN_ID,REDSGN_NTE_TYPE_ID,NOTES,CRETD_BY_CD,CRETD_DT)
		SELECT DISTINCT REDSGN_ID, 4, 'H1 Customer Name has been updated per Mach5', 1, GETDATE()
		FROM @COWSTbl
		WHERE REDSGN_ID IS NOT NULL

		--Set the extract code in BPM view
		set @dSQL = ''
		set @dSQL = 'EXECUTE ( ''begin BPMF_OWNER.PKG_BPMF_COWS.proc_BPM_COWS_H1_NME_CHNG(''''' + @H1_CUST_ID + ''''',''''Y''''); end;'') AT NRMBPM;'
		EXEC sp_executesql @dSQL
		END	
		
		DELETE FROM @COWSTbl
		SET @dSQL = NULL
		UPDATE @BPM_COWS_NRFC SET Flag=1 WHERE ID=@Ctr and Flag=0
		SET @Ctr = @Ctr + 1
	END

END TRY
BEGIN CATCH
	EXEC dbo.insertErrorInfo
END CATCH    
END